﻿----Create a buffer of the route layer

CREATE VIEW demo.routebuffer AS 
 
  SELECT 
  myroutes.id, 
  st_buffer(myroutes.geom, myroutes.buffer) AS  buffergeom,
myroutes.my_interest
   
FROM demo.myroutes;

---Create search results layer using a spatial function

CREATE VIEW demo.poi_near_route AS 
 
SELECT   
 p.ogc_fid, 
 p.wkb_geometry, 
 p.name,
 p.classdesc, 
 p.weekdayopening, 
 p.weekendopening, 
 p.pointx_cla,
 p.displayimage
   FROM 
 demo.osmmpoi_lk p, 
 demo.routebuffer rb

  WHERE st_intersects(rb.buffergeom, p.wkb_geometry) 
 AND 
 rb.my_interest = p.pointx_cla::integer;


 --Create Trigger Function to delete old records from the myroutes
 CREATE OR REPLACE FUNCTION demo.tf_deleterecords()
  RETURNS trigger AS
$BODY$

BEGIN

IF TG_OP = 'INSERT' THEN

EXECUTE 'DELETE FROM demo.myroutes' ;
return new;
ELSE RETURN NEW;
END IF;

END;

---create trigger on routes table

CREATE TRIGGER delete_records
  BEFORE INSERT
  ON demo.myroutes
  FOR EACH ROW
  EXECUTE PROCEDURE demo.tf_deleterecords();
